var Wxss = require('./wxss');
var path = require('path');
var fs = require('fs');
var chalk = require('chalk');
var debug = require('debug')('wevue');
var Wxml = require('./wxml');
var Wxss = require('./wxss');

//将backend.wxml backend.wxss合成一个文件

function readFile(file) {
    if (fs.existsSync(file)) {
        return fs.readFileSync(file, 'utf8');
    }
    return null;
}

module.exports = function(wxFolder, vueFolder, rootFolder, wevueFolder, program) {

    var templateFile, destFile, wxmlFile, wxssFile;
    if (program.ver == 2) {
        //新版本
        templateFile = path.join(wevueFolder, 'template' + program.ver, "app.vue");
        destFile = path.join(vueFolder, 'src', 'app.vue');
        wxmlFile = path.join(wxFolder, "app.wxml");
        wxssFile = path.join(wxFolder, "app.wxss");
    } else {
        //老版本
        templateFile = path.join(wevueFolder, 'template', "backend.vue");
        destFile = path.join(vueFolder, 'src', 'backend.vue');
        wxmlFile = path.join(wxFolder, "backend.wxml");
        wxssFile = path.join(wxFolder, "backend.wxss");
    }

    debug('==> templateFile', templateFile);
    debug('==> wxmlFile', wxmlFile);
    debug('wxssFile', wxssFile);
    debug('destFile', destFile);

    var wxml = readFile(wxmlFile);
    var wxss = readFile(wxssFile) || "";


    if (!wxml) {
        console.log(chalk.yellow(wxmlFile + '不存在'));
        return;
    }

    Wxml(wxml, program.close, function(err, xml) {
        var template = fs.readFileSync(templateFile, 'utf8');

        var xml = template.replace('{{XML}}', xml).replace('{{WXSS}}', Wxss(wxss));
        debug(wxml);

        var srcFolder = path.join(vueFolder, 'src');

        if (!fs.existsSync(srcFolder)) {
            fs.mkdirSync(srcFolder);
        }

        debug(destFile, wxml);
        fs.writeFileSync(destFile, xml);
    });
}
