"use strict";
var path = require('path')
var config = require('./config')
var ExtractTextPlugin = require('extract-text-webpack-plugin')


exports.cssLoaders = function (options) {
  options = options || {}
  // generate loader string to be used with extract text plugin
  function generateLoaders(loaders) {
    var sourceLoader = loaders.map(function (loader) {
      var extraParamChar
      if (/\?/.test(loader)) {
        loader = loader.replace(/\?/, '-loader?')
        extraParamChar = '&'
      } else {
        loader = loader + '-loader'
        extraParamChar = '?'
      }
      return loader + (options.sourceMap ? extraParamChar + 'sourceMap' : '')
    }).join('!')

    // Extract CSS when that option is specified
    // (which is the case during production build)
    if (options.extract) {
      return ExtractTextPlugin.extract({
        use: sourceLoader,
        fallback: 'vue-style-loader'
      })
    } else {
      return ['vue-style-loader', sourceLoader].join('!')
    }
  }

  // http://vuejs.github.io/vue-loader/en/configurations/extract-css.html
  return {
    png: generateLoaders(['url?limit=10000']),
    css: generateLoaders(['css']),
    postcss: generateLoaders(['css']),
    less: generateLoaders(['css', 'less'])
  }
}

// Generate loaders for standalone style files (outside of .vue)
exports.styleLoaders = function (options) {
  var output = []
  var loaders = exports.cssLoaders(options)
  for (var extension in loaders) {
    var loader = loaders[extension]
    output.push({
      test: new RegExp('\\.' + extension + '$'),
      loader: loader
    })
  }
  return output
}


exports.getAssetsList = function (config, type) {
  var css = config.css || []
  var js = config.js || []
  if (type === "admin") {
    js.push("./admin.build.js")
  } else {
    js.push("./mobile.build.js")
  }


  var ret = []
  var i = 0;
  for (i = 0; i < css.length; i++) {
    ret.push(css[i])
  }
  for (i = 0; i < js.length; i++) {
    ret.push(js[i])
  }

  return ret


}
exports.getWebpackBabelLoaderExclude = function(){
  let ret = ""
  let list = config.packageNameList||[]

  ret = list.join("|")
  ret = `node_modules\/(${ret})`
  let retExp = new RegExp(ret)
  return retExp
}