
import { pageOnLoad, pageOnShow, pageOnReady, pageOnHide, pageOnUnload, pageOnPullDownRefresh, pageOnShareAppMessage, pageOnReachBottom } from '../lifecycle'
import { pageFilter } from '../filters/page-data-methods-filter.js'

export function defaultPageMixins(arg={componentsList:{},mixinsList:{},directivesList:{},pageConfig:{}}) {
    /**
     * @lzq
     * 局部组件、混合、指令的添加
     * 插件只能是全局的
     */
    let localComponents = {}
    let localMixins = {}
    let localDirectives = {}
    let pageConfig = arg.pageConfig||{}//页面json配置文件

    localComponents = arg.componentsList||{}
    localMixins = arg.mixinsList||{}
    let localMixinsList = []
    for(let i in localMixins){
        localMixinsList.push(localMixins[i])
    }

    localDirectives = arg.directivesList||{}

    
    

    let filterRet = {}
    filterRet = pageFilter(pageConfig)
    return {
        methods: {
            setData(newVal = {}) {
                Object.assign(this, newVal)
            },
            $getAppInstence(){
                return this.$parent
            },
            ...filterRet.methods
        },
        computed: {
            data() {
                return this
            }
        },
        data() {
            return {
                __WEVUE_ROUTE: '',
                ...filterRet.data
            }
        },
        mixins:localMixinsList,
        components: localComponents,
        directives:localDirectives,
        beforeCreate() {

        },
        created() {
            __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH] = __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH] || {}
            __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH] = this
            this.__WEVUE_PATH = this.$route.path

            pageOnLoad.apply(this,[this.$route.query])
            pageOnShow.apply(this)
        },
        beforeMount() {

        },
        mounted() {
            __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH] = __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH] || {}
            __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH] = this

            pageOnReady.apply(this)

        },
        beforeUpdate() {

        },
        updated() {

        },
        beforeDestroy() {
            pageOnHide.apply(this)
        },
        destroyed() {
            pageOnUnload.apply(this)
        },
        ...filterRet.vueAttr
    }
} 